//////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//Petroglyph Confidential Source Code -- Do Not Distribute
//
// (Auto generated by PGSLCodeGenerator)
//Platform: MAX
//////////////////////////////////////////////////////////////////////////////////////////////////////////
#define PGSL_MAX
#define PGSL_DX9
#include"..\common\PGSLAlways.pgh"
#include"..\common\AlamoEngine.pgh"

float g_ShaderFileDummyVariable : SHADER_FILE_ANNOTATION
<
string _ALAMO_RENDER_PHASE = "Heat";
string _ALAMO_VERTEX_PROC = "Mesh";
string _ALAMO_VERTEX_TYPE = "alD3dVertNU2C";
bool _ALAMO_TANGENT_SPACE = false;
bool _ALAMO_Z_SORT = false;
>;

#define PGSL_PS_INPUT_mesh_heat PGSL_VS_OUTPUT_mesh_heat



/////////////////////////////////////////////////////////////////////
//VERTEX SHADER INPUTS
/////////////////////////////////////////////////////////////////////
float UVScale
<
string UIName = "UVScale";
>
 = 1.0;

float2 UVScrollRate
<
string UIName = "UVScrollRate";
>
 = {0, 0};

float CodeDistortionFactor
<
bool IsArtParam = true;
>
 = 1;

struct PGSL_VS_INPUT_mesh_heat
{
	float3 Pos  : PGSL_POSITION;
	float3 Normal  : PGSL_NORMAL;
	float2 BaseTexUV  : PGSL_TEXCOORD0;
	float4 Color  : PGSL_COLOR0;
};



/////////////////////////////////////////////////////////////////////
//VERTEX SHADER OUTPUTS
/////////////////////////////////////////////////////////////////////
struct PGSL_VS_OUTPUT_mesh_heat
{
	float4 Pos  : PGSL_SV_POSITION;
	float2 BaseTexUV  : PGSL_TEXCOORD0;
	float4 Diffuse  : PGSL_TEXCOORD1;
};



/////////////////////////////////////////////////////////////////////
//VERTEX SHADER SHARED STRUCT
/////////////////////////////////////////////////////////////////////
struct PGSL_VS_SHARED_mesh_heat
{
	float4x4 World;
	float4 Pos;
	float3 Normal;
	float2 BaseTexUV;
	float4 VertexColor;
	float4 SurfaceDiffuse;
	float3 SurfaceSpecular;
	float4 WorldPos;
	float3 Diffuse;
};



/////////////////////////////////////////////////////////////////////
//VERTEX SHADERS
/////////////////////////////////////////////////////////////////////


void pre_vs_world_PART(inout PGSL_VS_INPUT_mesh_heat input, inout PGSL_VS_OUTPUT_mesh_heat output, inout PGSL_VS_SHARED_mesh_heat shared_vars)
{
	shared_vars.World = g_World;
}



void pre_vs_position_PART(inout PGSL_VS_INPUT_mesh_heat input, inout PGSL_VS_OUTPUT_mesh_heat output, inout PGSL_VS_SHARED_mesh_heat shared_vars)
{
	shared_vars.Pos = float4(input.Pos.xyz, 1.0);
}



void pre_vs_normal_PART(inout PGSL_VS_INPUT_mesh_heat input, inout PGSL_VS_OUTPUT_mesh_heat output, inout PGSL_VS_SHARED_mesh_heat shared_vars)
{
	shared_vars.Normal = input.Normal.xyz;
}



void pre_vs_base_uv_PART(inout PGSL_VS_INPUT_mesh_heat input, inout PGSL_VS_OUTPUT_mesh_heat output, inout PGSL_VS_SHARED_mesh_heat shared_vars)
{
	shared_vars.BaseTexUV = input.BaseTexUV;
}



void pre_vs_vertex_color_PART(inout PGSL_VS_INPUT_mesh_heat input, inout PGSL_VS_OUTPUT_mesh_heat output, inout PGSL_VS_SHARED_mesh_heat shared_vars)
{
	shared_vars.VertexColor = input.Color;
}



void vs_identity_surface_material_PART(in PGSL_VS_INPUT_mesh_heat input, inout PGSL_VS_OUTPUT_mesh_heat output, inout PGSL_VS_SHARED_mesh_heat shared_vars)
{
	shared_vars.SurfaceDiffuse = float4(1, 1, 1, 1);
	shared_vars.SurfaceSpecular = float3(1, 1, 1);
}



void vs_mesh_PART(in PGSL_VS_INPUT_mesh_heat input, inout PGSL_VS_OUTPUT_mesh_heat output, inout PGSL_VS_SHARED_mesh_heat shared_vars)
{
	//xform to projection space
#if defined(PGSL_MAX)
	output.Pos = mul(shared_vars.Pos, g_World);
	output.Pos = mul(output.Pos, g_View);
	output.Pos = mul(output.Pos, g_Proj);
#else
	output.Pos = mul(shared_vars.Pos, g_WorldViewProj);
#endif
	
	//save world pos
	shared_vars.WorldPos = mul(shared_vars.Pos, shared_vars.World);
}



void vs_base_uv_scale_PART(in PGSL_VS_INPUT_mesh_heat input, inout PGSL_VS_OUTPUT_mesh_heat output, inout PGSL_VS_SHARED_mesh_heat shared_vars)
{
	shared_vars.BaseTexUV.xy *= UVScale;
   output.BaseTexUV = shared_vars.BaseTexUV;
}



void vs_base_uv_scroll_PART(in PGSL_VS_INPUT_mesh_heat input, inout PGSL_VS_OUTPUT_mesh_heat output, inout PGSL_VS_SHARED_mesh_heat shared_vars)
{
	shared_vars.BaseTexUV += g_ElapsedTime*UVScrollRate;
   output.BaseTexUV = shared_vars.BaseTexUV;
}



void vs_vertex_alpha_modulate_PART(in PGSL_VS_INPUT_mesh_heat input, inout PGSL_VS_OUTPUT_mesh_heat output, inout PGSL_VS_SHARED_mesh_heat shared_vars)
{
	shared_vars.SurfaceDiffuse.a *= shared_vars.VertexColor.a;
}



void vs_code_distortion_PART(in PGSL_VS_INPUT_mesh_heat input, inout PGSL_VS_OUTPUT_mesh_heat output, inout PGSL_VS_SHARED_mesh_heat shared_vars)
{
	shared_vars.SurfaceDiffuse *= CodeDistortionFactor;
}



void vs_compose_surface_diffuse_PART(in PGSL_VS_INPUT_mesh_heat input, inout PGSL_VS_OUTPUT_mesh_heat output, inout PGSL_VS_SHARED_mesh_heat shared_vars)
{
	shared_vars.Diffuse = shared_vars.SurfaceDiffuse.rgb;
	output.Diffuse = shared_vars.SurfaceDiffuse;
}

PGSL_VS_OUTPUT_mesh_heat pass_vs_PGSL_VS_MAIN_mesh_heat(PGSL_VS_INPUT_mesh_heat meta_shader_in)
{
	PGSL_VS_OUTPUT_mesh_heat meta_shader_out = (PGSL_VS_OUTPUT_mesh_heat)0;
	PGSL_VS_SHARED_mesh_heat meta_shader_shared = (PGSL_VS_SHARED_mesh_heat)0;
	pre_vs_world_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	pre_vs_position_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	pre_vs_normal_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	pre_vs_base_uv_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	pre_vs_vertex_color_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	vs_identity_surface_material_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	vs_mesh_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	vs_base_uv_scale_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	vs_base_uv_scroll_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	vs_vertex_alpha_modulate_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	vs_code_distortion_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	vs_compose_surface_diffuse_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	return meta_shader_out;
}















/////////////////////////////////////////////////////////////////////
//PIXEL SHADER INPUTS
/////////////////////////////////////////////////////////////////////
PGSL_TEXTURE2D DistortionTexture
<
string UIName = "DistortionTexture";
string UIType = "bitmap";
string SamplerEnum = "AL_SAMPLER_UVWRAP_MIN_MAG_MIP_BILINEAR";
>
;
PGSL_SAMPLER DistortionTextureSampler PGSL_SAMPLER_REG(0)
<
string UIName = "DistortionTexture";
string UIType = "bitmap";
string SamplerEnum = "AL_SAMPLER_UVWRAP_MIN_MAG_MIP_BILINEAR";
PGSL_BIND_TO_TEXTURE(DistortionTexture)
string SamplerRegister = "0";
>
PGSL_SAMPLER_STATE(DistortionTexture);




/////////////////////////////////////////////////////////////////////
//PIXEL SHADER OUTPUTS
/////////////////////////////////////////////////////////////////////
struct PGSL_PS_OUTPUT_mesh_heat
{
	float4 Color0  : PGSL_TARGET0;
};



/////////////////////////////////////////////////////////////////////
//PIXEL SHADER SHARED STRUCT
/////////////////////////////////////////////////////////////////////
struct PGSL_PS_SHARED_mesh_heat
{
	float2 BaseTexUV;
	float4 SurfaceDiffuse;
	float3 SurfaceSpecular;
	float3 Diffuse;
};



/////////////////////////////////////////////////////////////////////
//PIXEL SHADERS
/////////////////////////////////////////////////////////////////////


void pre_ps_base_uv_PART(inout PGSL_PS_INPUT_mesh_heat input, inout PGSL_PS_OUTPUT_mesh_heat output, inout PGSL_PS_SHARED_mesh_heat shared_vars)
{
	shared_vars.BaseTexUV = input.BaseTexUV;
}



void ps_identity_surface_material_PART(in PGSL_PS_INPUT_mesh_heat input, inout PGSL_PS_OUTPUT_mesh_heat output, inout PGSL_PS_SHARED_mesh_heat shared_vars)
{
	shared_vars.SurfaceDiffuse = float4(1, 1, 1, 1);
	shared_vars.SurfaceSpecular = float3(1, 1, 1);
}



void ps_heat_PART(in PGSL_PS_INPUT_mesh_heat input, inout PGSL_PS_OUTPUT_mesh_heat output, inout PGSL_PS_SHARED_mesh_heat shared_vars)
{
	float4 texel = PGSL_TEX2D(DistortionTexture, DistortionTextureSampler, shared_vars.BaseTexUV);
   float3 delta = texel.rgb - float3(0.5, 0.5, 0.5);
   delta *= input.Diffuse.a;

   texel.rgb = float3(0.5, 0.5, 0.5) + delta;
   texel.a = input.Diffuse.a;
	
	shared_vars.SurfaceDiffuse *= texel;
}



void ps_compose_surface_diffuse_PART(in PGSL_PS_INPUT_mesh_heat input, inout PGSL_PS_OUTPUT_mesh_heat output, inout PGSL_PS_SHARED_mesh_heat shared_vars)
{
  shared_vars.Diffuse = shared_vars.SurfaceDiffuse.rgb;
  output.Color0 = shared_vars.SurfaceDiffuse;
}

PGSL_PS_OUTPUT_mesh_heat pass_ps_PGSL_PS_MAIN_mesh_heat(PGSL_PS_INPUT_mesh_heat meta_shader_in)
{
	PGSL_PS_OUTPUT_mesh_heat meta_shader_out = (PGSL_PS_OUTPUT_mesh_heat)0;
	PGSL_PS_SHARED_mesh_heat meta_shader_shared = (PGSL_PS_SHARED_mesh_heat)0;
	pre_ps_base_uv_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	ps_identity_surface_material_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	ps_heat_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	ps_compose_surface_diffuse_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	return meta_shader_out;
}



/////////////////////////////////////////////////////////////////////
//SHADER'S PASSES
/////////////////////////////////////////////////////////////////////
PGSL_TECHNIQUE_BEGIN
	PGSL_PASS_BEGIN(pass_0, 
	<
		string _RasterizeState_ = "ALRS_DEFAULT";string _BlendState_ = "ALBS_ALPHA_BLEND";string _DepthStencilState_ = "ALDS_DEPTHLESSEQUALNOWRITE_STENCILDISABLE_SRGBWRITEDISABLE";
	>)
		PGSL_PASS_VS(pass_vs_PGSL_VS_MAIN_mesh_heat, 0)
		PGSL_PASS_PS(pass_ps_PGSL_PS_MAIN_mesh_heat, 0)
	PGSL_PASS_END
PGSL_TECHNIQUE_END



