//////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//Petroglyph Confidential Source Code -- Do Not Distribute
//
// (Auto generated by PGSLCodeGenerator)
//Platform: MAX
//////////////////////////////////////////////////////////////////////////////////////////////////////////
#define PGSL_MAX
#define PGSL_DX9
#include"..\common\PGSLAlways.pgh"
#include"..\common\AlamoEngine.pgh"

float g_ShaderFileDummyVariable : SHADER_FILE_ANNOTATION
<
string _ALAMO_RENDER_PHASE = "Transparent";
string _ALAMO_VERTEX_PROC = "Mesh";
string _ALAMO_VERTEX_TYPE = "alD3dVertN";
bool _ALAMO_TANGENT_SPACE = false;
bool _ALAMO_Z_SORT = false;
>;

#define PGSL_PS_INPUT_mesh_solid_color PGSL_VS_OUTPUT_mesh_solid_color



/////////////////////////////////////////////////////////////////////
//VERTEX SHADER INPUTS
/////////////////////////////////////////////////////////////////////
struct PGSL_VS_INPUT_mesh_solid_color
{
	float3 Pos  : PGSL_POSITION;
	float3 Normal  : PGSL_NORMAL;
};



/////////////////////////////////////////////////////////////////////
//VERTEX SHADER OUTPUTS
/////////////////////////////////////////////////////////////////////
struct PGSL_VS_OUTPUT_mesh_solid_color
{
	float4 Pos  : PGSL_SV_POSITION;
	float Fog  : PGSL_TEXCOORD0;
};



/////////////////////////////////////////////////////////////////////
//VERTEX SHADER SHARED STRUCT
/////////////////////////////////////////////////////////////////////
struct PGSL_VS_SHARED_mesh_solid_color
{
	float4x4 World;
	float4 Pos;
	float3 Normal;
	float4 WorldPos;
};



/////////////////////////////////////////////////////////////////////
//VERTEX SHADERS
/////////////////////////////////////////////////////////////////////


void pre_vs_world_PART(inout PGSL_VS_INPUT_mesh_solid_color input, inout PGSL_VS_OUTPUT_mesh_solid_color output, inout PGSL_VS_SHARED_mesh_solid_color shared_vars)
{
	shared_vars.World = g_World;
}



void pre_vs_position_PART(inout PGSL_VS_INPUT_mesh_solid_color input, inout PGSL_VS_OUTPUT_mesh_solid_color output, inout PGSL_VS_SHARED_mesh_solid_color shared_vars)
{
	shared_vars.Pos = float4(input.Pos.xyz, 1.0);
}



void pre_vs_normal_PART(inout PGSL_VS_INPUT_mesh_solid_color input, inout PGSL_VS_OUTPUT_mesh_solid_color output, inout PGSL_VS_SHARED_mesh_solid_color shared_vars)
{
	shared_vars.Normal = input.Normal.xyz;
}



void vs_mesh_PART(in PGSL_VS_INPUT_mesh_solid_color input, inout PGSL_VS_OUTPUT_mesh_solid_color output, inout PGSL_VS_SHARED_mesh_solid_color shared_vars)
{
	//xform to projection space
#if defined(PGSL_MAX)
	output.Pos = mul(shared_vars.Pos, g_World);
	output.Pos = mul(output.Pos, g_View);
	output.Pos = mul(output.Pos, g_Proj);
#else
	output.Pos = mul(shared_vars.Pos, g_WorldViewProj);
#endif
	
	//save world pos
	shared_vars.WorldPos = mul(shared_vars.Pos, shared_vars.World);
}



void vs_fog_PART(in PGSL_VS_INPUT_mesh_solid_color input, inout PGSL_VS_OUTPUT_mesh_solid_color output, inout PGSL_VS_SHARED_mesh_solid_color shared_vars)
{
	float fog = length(output.Pos.xyz);
	output.Fog = saturate(g_FogValues.x*fog + g_FogValues.y);
}

PGSL_VS_OUTPUT_mesh_solid_color pass_vs_PGSL_VS_MAIN_mesh_solid_color(PGSL_VS_INPUT_mesh_solid_color meta_shader_in)
{
	PGSL_VS_OUTPUT_mesh_solid_color meta_shader_out = (PGSL_VS_OUTPUT_mesh_solid_color)0;
	PGSL_VS_SHARED_mesh_solid_color meta_shader_shared = (PGSL_VS_SHARED_mesh_solid_color)0;
	pre_vs_world_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	pre_vs_position_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	pre_vs_normal_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	vs_mesh_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	vs_fog_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	return meta_shader_out;
}















/////////////////////////////////////////////////////////////////////
//PIXEL SHADER INPUTS
/////////////////////////////////////////////////////////////////////
float4 Color  : COLOR
<
string UIName = "Color";
string UIType = "ColorSwatch";
bool GammaCorrect = true;
>
 = {1, 1, 1, 1};




/////////////////////////////////////////////////////////////////////
//PIXEL SHADER OUTPUTS
/////////////////////////////////////////////////////////////////////
struct PGSL_PS_OUTPUT_mesh_solid_color
{
	float4 Color0  : PGSL_TARGET0;
};



/////////////////////////////////////////////////////////////////////
//PIXEL SHADER SHARED STRUCT
/////////////////////////////////////////////////////////////////////
struct PGSL_PS_SHARED_mesh_solid_color
{
};



/////////////////////////////////////////////////////////////////////
//PIXEL SHADERS
/////////////////////////////////////////////////////////////////////


void ps_solid_color_PART(in PGSL_PS_INPUT_mesh_solid_color input, inout PGSL_PS_OUTPUT_mesh_solid_color output, inout PGSL_PS_SHARED_mesh_solid_color shared_vars)
{
  output.Color0 = Color;
}



void ps_fog_PART(in PGSL_PS_INPUT_mesh_solid_color input, inout PGSL_PS_OUTPUT_mesh_solid_color output, inout PGSL_PS_SHARED_mesh_solid_color shared_vars)
{
	output.Color0.rgb = lerp(g_FogColor.rgb, output.Color0.rgb, input.Fog);
}

PGSL_PS_OUTPUT_mesh_solid_color pass_ps_PGSL_PS_MAIN_mesh_solid_color(PGSL_PS_INPUT_mesh_solid_color meta_shader_in)
{
	PGSL_PS_OUTPUT_mesh_solid_color meta_shader_out = (PGSL_PS_OUTPUT_mesh_solid_color)0;
	PGSL_PS_SHARED_mesh_solid_color meta_shader_shared = (PGSL_PS_SHARED_mesh_solid_color)0;
	ps_solid_color_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	ps_fog_PART(meta_shader_in, meta_shader_out, meta_shader_shared);
	return meta_shader_out;
}



/////////////////////////////////////////////////////////////////////
//SHADER'S PASSES
/////////////////////////////////////////////////////////////////////
PGSL_TECHNIQUE_BEGIN
	PGSL_PASS_BEGIN(pass_0, 
	<
		string _RasterizeState_ = "ALRS_DEFAULT";string _BlendState_ = "ALBS_ALPHA_BLEND";string _DepthStencilState_ = "ALDS_DEPTHLESSEQUALWRITE_STENCILDISABLE";
	>)
		PGSL_PASS_VS(pass_vs_PGSL_VS_MAIN_mesh_solid_color, 0)
		PGSL_PASS_PS(pass_ps_PGSL_PS_MAIN_mesh_solid_color, 0)
	PGSL_PASS_END
PGSL_TECHNIQUE_END



